/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2003 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include <string.h>
#include "tms.h"

void init_stat(struct master_creature *c) /* take racial bases and add random */
    {             /* adjustment.  After racial/species */
    long i, n[36];
    for (i=0;i<NUM_ATTRIBUTES;++i)
        c->attributes[i] += gender_attribute_adjustment[c->gender][i];
    for (i=0;i<NUM_ATTRIBUTES;++i)
        c->attributes[i] += age_attribute_adjustment[c->age_class][i];
    for(i=0;i<36;++i)
        n[i]=oner();
    c->attributes[AG]+=(n[0]+n[1]+n[2]+n[3]+n[4]);
    c->attributes[AL]+=(n[0]+n[5]+n[6]+n[7]+n[8]);
    c->attributes[CH]+=(n[0]+n[5]+n[9]+n[10]+n[11]);
    c->attributes[CO]+=(n[12]+n[13]+n[14]+n[15]+n[16]);
    c->attributes[DE]+=(n[0]+n[1]+n[2]+n[17]+n[18]);
    c->attributes[IN]+=(n[0]+n[5]+n[6]+n[19]+n[20]);
    c->attributes[KN]+=(n[0]+n[5]+n[6]+n[21]+n[22]);
    c->attributes[ME]+=(n[0]+n[5]+n[6]+n[23]+n[24]);
    c->attributes[PE]+=(n[0]+n[5]+n[25]+n[26]+n[27]);
    c->attributes[SPEED]+=(n[0]+n[1]+n[28]+n[29]+n[30]);
    c->attributes[ST]+=(n[12]+n[13]+n[31]+n[32]+n[33]);
    c->attributes[WI]+=(n[0]+n[5]+n[6]+n[34]+n[35]);
    for (i=0;i<NUM_ATTRIBUTES;++i)
        c->perm_attributes[i] = c->attributes[i];
    }

long oner(void)
    {
    return ((trandom() % 6) - (trandom() % 6));
    }

struct master_creature *master_creature_create(long race, long age_class, long
  gender)
    {
    struct master_creature *c;
    struct small_creature *sc;
    long skilltype, i, garbage;
    c=(struct master_creature *) calloc(1, sizeof(struct master_creature));
    *c=master_creatures[race];
    /* Unique creatures do not age, and are always middle aged.  */
    if (flag_check(c->flags, UNIQUE))
        age_class = MIDDLE_AGED;
    if (gender == MALE)
        c->natural_weight = (c->natural_weight * 11) / 10;
    if (gender == FEMALE)
        {
        c->natural_weight = (c->natural_weight * 9) / 10;
        flag_set(&c->flags, C_FEMALE);
        }
    c->natural_weight = random_adjust(c->natural_weight);
    strncpy(c->title, "the ", 255);
    c->title[255] = '\0';
    strncat(c->title, c->species, max(0, 255 - strlen(c->title)));
    c->title[255] = '\0';
    flag_set(&c->flags, C_WANDERING);
    c->age_class=age_class;
    if (race < NUM_RACES)
        c->age = age_class_years[race][age_class - 1] +
            trandom() %
            (age_class_years[race][age_class] -
            age_class_years[race][age_class - 1]);
    else
        c->age = age_class_years[FIRST_NONHUMAN][age_class - 1] +
            trandom() %
            (age_class_years[FIRST_NONHUMAN][age_class] -
            age_class_years[FIRST_NONHUMAN][age_class - 1]);
    c->gender=gender;
    c->skills=(struct skills_struct *) calloc(1, sizeof(struct skills_struct));
    c->skills->me = c->skills;
    if (!(flag_check(c->flags, HUMAN))) skilltype=7;
        else skilltype=race;
    for(i=0;i<NUM_SKILLS;++i)
        c->skills->bv[i]=c->skills->ub[i]=racial_base_skills[i][skilltype];
    c->stati = (struct adj_struct *) calloc(1, sizeof(struct adj_struct));
    c->stati->me = c->stati;
    for(i=0;i<NUM_STATI;++i)
        {
        c->stati->time[i] = adjustment_info[i].min *
            adjustment_info[i].time_increment;
        c->stati->permanent[i] = 0;
        }
    init_stat(c);
    if ((flag_check(c->flags, HUMAN)) || (c->race == ANGEL))
        {
        /* Initialize faith */
        c->faith = (struct faith_struct *) calloc(1, sizeof(struct
          faith_struct));
        c->faith->me = c->faith;
        c->faith->breath_prayer = NULL;
        c->faith->faith = 0;
        random_select(gift_dist, &c->faith->gifts, &garbage);
        while (trandom() % (10 + 10 * (flag_check(c->faith->gifts,
          GIFT_FAITH))) != 0)
            ++c->faith->faith;
        for(i = 0; i < NUM_PRAYERS; ++i)
            {
            c->faith->prayers[i] = 0;
            if (flag_check(prayers[i].gifts, c->faith->gifts))
                while (trandom() % max(1, c->faith->faith) != 0)
                    ++c->faith->prayers[i];
            }
        }
    else
        c->faith = NULL;
    c->follow=0;
    c->mount=NULL;
    c->wear_wield=c->pack=NULL;
    c->attack_time = 1;
    if (flag_check(c->flags, LEFT_HANDED))
        {
        if (!(trandom()%CHANCE_OTHER_HANDEDNESS))
            flag_reset(&c->flags, LEFT_HANDED);
        }
    else if (!(trandom()%CHANCE_OTHER_HANDEDNESS))
            flag_set(&c->flags, LEFT_HANDED);
    if (c->au > 0)
        c->au = trandom() % c->au + trandom() % c->au;
    if (c->el > 0)
        c->el = trandom() % c->el + trandom() % c->el;
    if (c->si > 0)
        c->si = trandom() % c->si + trandom() % c->si;
    if (c->cu > 0)
        c->cu = trandom() % c->cu + trandom() % c->cu;
    sc = (struct small_creature *) calloc(1, sizeof(struct small_creature));
    sc->me = sc;
    sc->extended = c;
    calc_ready(sc);
    sc->x = 0;
    sc->y = 0;
    if (!(flag_check(sc->flags, HUMAN)))
        if (skill_check(sc, sc->extended->skills->av[STEALTH], DIFFICULT,
          SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE|
          SKILL_CHECK_NO_SIGHT_ADJUST) > 0)
            {
            flag_set(&c->flags, HIDDEN);
            flag_set(&sc->flags, HIDDEN);
            }
    free(sc);
    return c;
    }

struct small_creature *extended_creature_create(long race, long age_class, long
  gender)
    {
    struct master_creature *master_c;
    struct small_creature *result;
    struct clist *this_clist;
    master_c = master_creature_create(race, age_class, gender);
    result = (struct small_creature *) calloc(1, sizeof(struct small_creature));
    result->me = result;
    result->name = NULL;
    result->identity = master_c->race;
    result->age = master_c->age;
    result->att = master_c->att;
    result->dmg = master_c->dmg;
    result->hv = master_c->phv;
    result->def = master_c->def;
    result->wounded = 0;
    result->sp = master_c->attributes[SPEED];
    result->epvalue = creature_epvalue(master_c);
    result->price = 0;
    result->nextaction=game_variables->elapsed_units;
    result->flags = master_c->flags;
    result->follow = NULL;
    result->followed_by = NULL;
    result->hostile = NULL;
    result->attack_time = master_c->attack_time;
    result->extended = master_c;
    this_clist = (struct clist *) calloc(1, sizeof(struct clist));
    this_clist->me = this_clist;
    this_clist->current = result;
    this_clist->next = master_clist;
    master_clist = this_clist;
    return result;
    }

struct small_creature *creature_create(long race, long age_class, long gender)
    {
    struct small_creature *result;
    result = extended_creature_create(race, age_class, gender);
    free_master_creature(result->extended);
    result->extended = NULL;
    return result;
    }

void interview(void)
    {
    char resp, input[256];
    long race, gender, age_class, age, my_positive, result, i;
    result = 0;
    age_class = 0;
    clear();
    fs_pmsg("Ok; I've got a few questions which I would like for you to answer.");
    fs_pmsg("Please try to answer them honestly.");
    fs_morewait();
    clear();
    fs_pmsg("Do you see yourself as being one of the fantasy races, or should I just put");
    fs_pmsg("you down as human?");
    fs_pmsg("");
    fs_pmsg("\ta: Janra");
    fs_pmsg("\tb: Jec");
    fs_pmsg("\tc: Nor'krin");
    fs_pmsg("\td: Shal");
    fs_pmsg("\te: Tuz");
    fs_pmsg("\tf: Urvanovestilli");
    fs_pmsg("\tg: Yedidia");
    fs_pmsg("");
    fs_pmsg("\th: Just put me down as human.");
    fs_pmsg("");
    for(resp=tgetc(); (resp < 'a' || resp > 'h'); resp=tgetc());
    if (resp == 'h')
        race = JEC; /* Jec are the most basically human.  */
    else
        race = resp - 'a';
    fs_morewait();
    clear();
    fs_pmsg("Are you (a) male or (b) female?");
    for(resp=tgetc(); (resp < 'a' || resp > 'b'); resp=tgetc());
    gender = resp - 'a';
    fs_morewait();
    clear();
    fs_pmsg("");
    fs_pmsg("How old are you?");
    tgets(input);
    sscanf(input, "%ld", &age);
    if (age > age_class_years[race][0]) age_class=1;
    if (age > age_class_years[race][1]) age_class=2;
    if (age > age_class_years[race][2]) age_class=3;
    if (age > age_class_years[race][3]) age_class=4;
    if (age > age_class_years[race][4]) age_class=5;
    fs_morewait();
    fs_pmsg("And now for the questions...");
    fs_anykey();
    player = extended_creature_create(race, age_class, gender);
    for(i = 0; i < NUM_ATTRIBUTES; ++i)
        player->extended->attributes[i] = 0;
    my_positive = ask_question("Have you ever made an artistic creation?", 2,
      -4, IN);
    if (my_positive)
        {
        ask_question("Have you worked with more than five media?", 1, -1, IN);
        ask_question("Has your artwork ever won an award?", 2, -1, IN);
        }
    ask_question("Do you have a lot of hobbies?", 2, 1, AL);
    ask_question("Have you ever taken dance lessons?", 1, -2, AG);
    ask_question("Do you have training in gymnastics?", 1, -2, AG);
    if (ask_question("Do you have any martial arts training?", 1, -2, AG))
        ask_question("Do you have dan rank or equivalent?", 2, 0, AG);
    if (ask_question("Have you ever kept your balance on a tightrope?", 2, -2,
      AG))
    result = ask_value("How many languages have you studied, including your \
mother tongue?", 2, 1, 50);
    player->extended->attributes[KN] += result/2;
    if (ask_question("Have you attended high school?", 1, -4, KN))
        if (ask_question("College?", 2, -2, KN))
            ask_question("Graduate or professional school?", 2, -2, KN);
    result = ask_question_internal("Do you work out?", 2, -4);
    if (result == 2)
        result += ask_question_internal("Frequently?", 2, -4);
    player->extended->attributes[CO] += result;
    player->extended->attributes[ST] += result;
    if (ask_question("Do you smoke?", -4, 1, CO))
        ask_question("Heavily?", -4, 0, CO);
    if (ask_question("Do you get sick?", -2, 2, CO))
        ask_question("Frequently?", -4, 1, CO);
    ask_question("Have you ever broken a bone?", -2, 2, CO);
    result = ask_value("What's your typing speed (WPM)?", 30, 10, 80);
    player->extended->attributes[DE] += result;
    player->extended->attributes[SPEED] += result;
    if (ask_question("Ever outrun another person?", 1, -4, SPEED))
        if (ask_question("Outrun a bicycle?", 1, -2, SPEED))
            ask_question("Outrun a car?", 2, -2, SPEED);
    ask_question("Do you play the piano or some other musical instrument?",
      1, -2, DE);
    ask_question("Have you ever picked a lock?", 2, -2, DE);
    if (ask_question("Have you ever fired a rifle?", 1, -1, DE))
    if (ask_question("Made the rank of marksman?", 1, -2, DE))
    if (ask_question("Sharpshooter?", 1, -2, DE))
        ask_question("Sharpshooter, bar VIII?", 2, -2, DE);
    ask_question("Are you interested in philosophy?", 1, -2, IN);
    if (ask_question("Do you study mathematics or a related discipline?", 2,
      -2, IN))
    if (ask_question("Have you ever achieved local rank in an academic \
competition?", 1, -2, IN))
    if (ask_question("State?", 2, -2, IN))
        ask_question("National?", 2, -1, IN);
      ask_value("How many pounds can you bench press?", 75, 10, 500);
    ask_question("Do you have 20/20 eyesight?", 1, -3, PE);
    if (ask_question("Can you read in dim light?", 1, -3, PE))
    ask_question("Do you know when someone is trying to sneak up behind you?",
      2, -2, PE);
    ask_question("Ever choose to walk away from a TV program that looked \
interesting?", 1, -4, WI);
    ask_question("Ever pull an all-nighter?", 1, -3, WI);
    for(i = 0; i < NUM_ATTRIBUTES; ++i)
        {
        player->extended->attributes[i] =
          min(max(player->extended->attributes[i], -25), 25);
        player->extended->attributes[i] +=
          racial_attribute_adjustment[race][i];
        player->extended->attributes[i] +=
          gender_attribute_adjustment[gender][i];
        player->extended->attributes[i] +=
          age_attribute_adjustment[age_class][i];
        }
    for(i = 0; i < NUM_ATTRIBUTES; ++i)
        player->extended->perm_attributes[i] =
          player->extended->attributes[i];
    calc_ready(player);
    clear();
    }

struct small_creature *new_npc_generic(long base_race)
    {
    long race, age_class, gender, garbage;
    age_class = 0;
    if (trandom() % 2 == 0)
        gender = MALE;
    else
        gender = FEMALE;
    switch(trandom() % 12)
        {
        case 0: case 1:
            age_class = CHILD;
        break;
        case 2: case 3: case 4: case 5:
            age_class = YOUNG_ADULT;
        break;
        case 6: case 7: case 8:
            age_class = MIDDLE_AGED;
        break;
        case 9: case 10:
            age_class = OLD;
        break;
        case 11:
            age_class = ANCIENT;
        break;
        }
    switch(base_race)
        {
        case JANRA:
            race = JANRA;
        break;
        case JEC:
            random_select(jec_land_human, &race, &garbage);
        break;
        case NORKRIN:
            random_select(norkrin_land_human, &race, &garbage);
        break;
        case SHAL:
            random_select(shal_land_human, &race, &garbage);
        break;
        case TUZ:
            random_select(tuz_land_human, &race, &garbage);
        break;
        case URVANOVESTILLI:
            random_select(urvanovestilli_land_human, &race, &garbage);
        break;
        case YEDIDIA:
            random_select(yedidia_land_human, &race, &garbage);
        break;
        default:
            race = JANRA;
        break;
        }
    return new_npc(race, age_class, gender);
    }

struct small_creature *new_npc(long race, long age_class, long gender)
    {
    long profession, garbage;
    struct small_creature *result;
    result = extended_creature_create(race, age_class, gender);
    switch(race)
        {
        case JANRA:
            random_select(janra_profession, &profession, &garbage);
            find_name(result, FILE_NAMES_JANRA);
        break;
        case JEC:
            random_select(jec_profession, &profession, &garbage);
            find_name(result, FILE_NAMES_JEC);
        break;
        case NORKRIN:
            random_select(norkrin_profession, &profession, &garbage);
            find_name(result, FILE_NAMES_NORKRIN);
        break;
        case SHAL:
            random_select(shal_profession, &profession, &garbage);
            find_name(result, FILE_NAMES_SHAL);
        break;
        case TUZ:
            random_select(tuz_profession, &profession, &garbage);
            find_name(result, FILE_NAMES_TUZ);
        break;
        case URVANOVESTILLI:
            random_select(urvanovestilli_profession, &profession, &garbage);
            find_name(result, FILE_NAMES_URVANOVESTILLI);
        break;
        case YEDIDIA:
            random_select(yedidia_profession, &profession, &garbage);
            find_name(result, FILE_NAMES_YEDIDIA);
        break;
        default:
            perror("Error: make_npc called with inappropriate race.");
            profession = ARTISAN;
        break;
        }
    initiate_profession(result, profession);
    /* Eventually have npc's named.  */
    return result;
    }

struct small_creature *new_adventurer()
    {
    long profession, garbage, race, age_class, gender;
    struct small_creature *result;
    age_class = 0;
    if (trandom() % 2 == 0)
        gender = MALE;
    else
        gender = FEMALE;
    switch(trandom() % 12)
        {
        case 0:
            age_class = CHILD;
        break;
        case 1: case 2: case 3: case 4: case 5:
            age_class = YOUNG_ADULT;
        break;
        case 6: case 7: case 8: case 9:
            age_class = MIDDLE_AGED;
        break;
        case 10:
            age_class = OLD;
        break;
        case 11:
            age_class = ANCIENT;
        break;
        }
    random_select(adventurer_race, &race, &garbage);
    result = extended_creature_create(race, age_class, gender);
    switch(race)
        {
        case JANRA:
            random_select(janra_adventurer, &profession, &garbage);
            find_name(result, FILE_NAMES_JANRA);
        break;
        case JEC:
            random_select(jec_adventurer, &profession, &garbage);
            find_name(result, FILE_NAMES_JEC);
        break;
        case NORKRIN:
            random_select(norkrin_adventurer, &profession, &garbage);
            find_name(result, FILE_NAMES_NORKRIN);
        break;
        case SHAL:
            random_select(shal_adventurer, &profession, &garbage);
            find_name(result, FILE_NAMES_SHAL);
        break;
        case TUZ:
            random_select(tuz_adventurer, &profession, &garbage);
            find_name(result, FILE_NAMES_TUZ);
        break;
        case URVANOVESTILLI:
            random_select(urvanovestilli_adventurer, &profession, &garbage);
            find_name(result, FILE_NAMES_URVANOVESTILLI);
        break;
        case YEDIDIA:
            random_select(yedidia_adventurer, &profession, &garbage);
            find_name(result, FILE_NAMES_YEDIDIA);
        break;
        default:
            perror("Error: make_npc called with inappropriate race.");
            profession = ARTISAN;
        break;
        }
    initiate_profession(result, profession);
    /* Eventually have npc's named.  */
    return result;
    }

void initiate_profession(struct small_creature *c, long profession)
    {
    long new_profession, garbage;
    if (c->extended != NULL)
        {
        if (profession <= LAST_REAL_PROFESSION)
            c->extended->profession = profession;
        switch(profession)
            {
            case ACROBAT:
                initiate_professional_skills(c, acrobat);
                acquire_item(c, DUNGEON_ITEM_NORMAL);
            break;
            case ANIMAL_HANDLER:
                initiate_professional_skills(c, animal_handler);
                /* Have one or more pets.  */
                acquire_item(c, DUNGEON_ITEM_NORMAL);
            break;
            case ARCHER:
                initiate_professional_skills(c, archer);
                acquire_item(c, LONGBOW);
                acquire_item(c, LONGBOW_ARROW);
                acquire_item(c, ARMOR_NORMAL);
                acquire_item(c, DUNGEON_ITEM_NORMAL);
            break;
            case HERBALIST:
                initiate_professional_skills(c, herbalist);
                acquire_item(c, HERBALIST_ITEM_NORMAL);
                while (trandom() % 2)
                    acquire_item(c, HERBALIST_ITEM_NORMAL);
                acquire_item(c, HERBAL_MEDICINES);
                acquire_item(c, DUNGEON_ITEM_NORMAL);
            break;
            case INTERPRETER:
                initiate_professional_skills(c, interpreter);
                acquire_item(c, DUNGEON_ITEM_NORMAL);
            break;
            case JACK_OF_ALL_TRADES:
                initiate_professional_skills(c, jack_of_all_trades);
                acquire_item(c, ARMOR_NORMAL);
                acquire_item(c, DUNGEON_ITEM_NORMAL);
            break;
            case MAN_AT_ARMS:
                initiate_professional_skills(c, man_at_arms);
                acquire_item(c, WEAPON_NORMAL);
                acquire_item(c, ARMOR_NORMAL);
                acquire_item(c, DUNGEON_ITEM_NORMAL);
            break;
            case MEDIC:
                initiate_professional_skills(c, medic);
                acquire_item(c, HERBAL_MEDICINES);
                acquire_item(c, DUNGEON_ITEM_NORMAL);
            break;
            case SCHOLAR:
                initiate_professional_skills(c, scholar);
                acquire_item(c, DUNGEON_ITEM_NORMAL);
            break;
            case SCOUT:
                initiate_professional_skills(c, scout);
                acquire_item(c, DUNGEON_ITEM_NORMAL);
                acquire_item(c, WEAPON_NORMAL);
            break;
            case WOODSMAN:
                initiate_professional_skills(c, woodsman);
                acquire_item(c, DUNGEON_ITEM_NORMAL);
            break;
            case ARTISAN: case BAKER: case BLACKSMITH: case BREWER: case
              CARPENTER: case COBBLER: case COOK: case DEVICE_MAKER: case
              FARMER: case FISHERMAN: case MASON: case MERCHANT: case MYSTIC:
              case SAILOR: case SHEPHERD: case TAILOR: case TANNER: case
              WEAVER:
            /* Right now, we do nothing for non-adventuring professions.  */
            break;
            case JANRA_ADVENTURER:
                random_select(janra_adventurer, &new_profession, &garbage);
                initiate_profession(c, new_profession);
            break;
            case JEC_ADVENTURER:
                random_select(jec_adventurer, &new_profession, &garbage);
                initiate_profession(c, new_profession);
            break;
            case NORKRIN_ADVENTURER:
                random_select(norkrin_adventurer, &new_profession, &garbage);
                initiate_profession(c, new_profession);
            break;
            case SHAL_ADVENTURER:
                random_select(shal_adventurer, &new_profession, &garbage);
                initiate_profession(c, new_profession);
            break;
            case TUZ_ADVENTURER:
                random_select(tuz_adventurer, &new_profession, &garbage);
                initiate_profession(c, new_profession);
            break;
            case URVANOVESTILLI_ADVENTURER:
                random_select(urvanovestilli_adventurer, &new_profession,
                  &garbage);
                initiate_profession(c, new_profession);
            break;
            case YEDIDIA_ADVENTURER:
                random_select(yedidia_adventurer, &new_profession, &garbage);
                initiate_profession(c, new_profession);
            break;
            case JANRA_MULTIPLE_PROFESSION:
                initiate_profession(c, JANRA_ADVENTURER);
                initiate_profession(c, JANRA_ADVENTURER);
                c->extended->profession = profession;
            break;
            case JEC_MULTIPLE_PROFESSION:
                initiate_profession(c, JEC_ADVENTURER);
                initiate_profession(c, JEC_ADVENTURER);
                c->extended->profession = profession;
            break;
            case NORKRIN_MULTIPLE_PROFESSION:
                initiate_profession(c, NORKRIN_ADVENTURER);
                initiate_profession(c, NORKRIN_ADVENTURER);
                c->extended->profession = profession;
            break;
            case SHAL_MULTIPLE_PROFESSION:
                initiate_profession(c, SHAL_ADVENTURER);
                initiate_profession(c, SHAL_ADVENTURER);
                c->extended->profession = profession;
            break;
            case TUZ_MULTIPLE_PROFESSION:
                initiate_profession(c, TUZ_ADVENTURER);
                initiate_profession(c, TUZ_ADVENTURER);
                c->extended->profession = profession;
            break;
            case URVANOVESTILLI_MULTIPLE_PROFESSION:
                initiate_profession(c, URVANOVESTILLI_ADVENTURER);
                initiate_profession(c, URVANOVESTILLI_ADVENTURER);
                c->extended->profession = profession;
            break;
            case YEDIDIA_MULTIPLE_PROFESSION:
                initiate_profession(c, YEDIDIA_ADVENTURER);
                initiate_profession(c, YEDIDIA_ADVENTURER);
                c->extended->profession = profession;
            break;
            }
        }
    }

/* This does not create proper inventory yet.  Should do a switch on real_skill
and give appropriate item, in use.  */

void initiate_professional_skills(struct small_creature *c, long
  template[NUM_DIST_SLOTS][3])
    {
    long i, real_skill, garbage, multiplier;
    multiplier = 1;
    while (trandom() % 2)
        ++multiplier;
    for(i = 0; i < NUM_DIST_SLOTS; ++i)
        if (template[i][1] > 0)
            {
            switch(template[i][0])
                {
                case ATTACK_HTH:
                    random_select(attack_hth_dist, &real_skill, &garbage);
                break;
                case ATTACK_MSL:
                    random_select(attack_msl_dist, &real_skill, &garbage);
                break;
                case FENCING:
                    random_select(fencing_dist, &real_skill, &garbage);
                break;
                case MUSIC:
                    random_select(music_dist, &real_skill, &garbage);
                break;
                default:
                    real_skill = template[i][0];
                break;
                }
            gain_ep(c, template[i][1]*multiplier);
            allocate_experience_internal(c, real_skill, c->extended->unspent_ep);
            switch(real_skill)
                {
                case ATTACK_AXE: case FENCING_AXE:
                    acquire_item(c, AXE);
                break;
                case ATTACK_CROSSBOW:
                    acquire_item(c, CROSSBOW);
                    acquire_item(c, CROSSBOW_BOLT);
                break;
                case ATTACK_DAGGER: case FENCING_DAGGER:
                    acquire_item(c, DAGGER);
                break;
                case ATTACK_HALBERD: case FENCING_HALBERD:
                    acquire_item(c, HALBERD);
                break;
                case ATTACK_LANCE:
                    acquire_item(c, LANCE);
                break;
                case ATTACK_LONGBOW:
                    acquire_item(c, LONGBOW);
                    acquire_item(c, LONGBOW_ARROW);
                break;
                case ATTACK_LONGSWORD: case FENCING_LONGSWORD:
                    acquire_item(c, LONGSWORD);
                break;
                case ATTACK_MACE: case FENCING_MACE:
                    acquire_item(c, MACE);
                break;
                case ATTACK_RAPIER: case FENCING_RAPIER:
                    acquire_item(c, RAPIER);
                break;
                case ATTACK_SHORTSWORD: case FENCING_SHORTSWORD:
                    acquire_item(c, SHORTSWORD);
                break;
                case ATTACK_TWO_HANDED_SWORD: case FENCING_TWO_HANDED_SWORD:
                    acquire_item(c, TWO_HANDED_SWORD);
                break;
                case MEDICINE:
                    acquire_item(c, MEDICAL_KIT);
                break;
                case MUSIC_FLUTE:
                    acquire_item(c, FLUTE);
                break;
                case MUSIC_HARP:
                    acquire_item(c, MUSIC_HARP);
                break;
                case MUSIC_LUTE:
                    acquire_item(c, MUSIC_LUTE);
                break;
                case PICK_LOCKS:
                    acquire_item(c, LOCK_PICKS);
                break;
                }
            }
    while (trandom() % 2 == 0)
        acquire_item(c, SUPPLIES_NORMAL);
    }

struct small_creature *guardian_angel_create(void)
    {
    struct small_creature *result;
    result = extended_creature_create(ANGEL, MIDDLE_AGED, MALE);
    strncpy(result->extended->title, "your guardian angel", 255);
    result->extended->title[255] = 0;
    add_permanent_status(result, STATUS_MIRACLE_AEGIS_OF_GOD, 1);
    return(result);
    }
